## com.fasterxml.jackson.databind.node
Class ArrayNode

    java.lang.Object
      com.fasterxml.jackson.databind.JsonNode
          com.fasterxml.jackson.databind.node.BaseJsonNode
              com.fasterxml.jackson.databind.node.ContainerNode<ArrayNode>
                  com.fasterxml.jackson.databind.node.ArrayNode

All Implemented Interfaces:
  com.fasterxml.jackson.core.TreeNode, JsonSerializable, Iterable<JsonNode>

    public class ArrayNode

extends ContainerNode<ArrayNode>

Node class that represents Arrays mapped from Json content.

Nested Class Summary

Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`ContainerNode.NoNodesIterator, ContainerNode.NoStringsIterator`

Field Summary
`protected ArrayList<JsonNode>` `_children`

Fields inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`_nodeFactory`

Fields inherited from class com.fasterxml.jackson.databind.JsonNode
`NO_NODES, NO_STRINGS`

Constructor Summary
`` `ArrayNode(JsonNodeFactory nc)`
`protected` `ArrayNode(JsonNodeFactory nc, ArrayList<JsonNode> children)`

Method Summary
`JsonNode` `_set(int index, JsonNode value)`
`ArrayNode` `add(BigDecimal v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(boolean v)` Method for adding specified boolean value at the end of this array.
`ArrayNode` `add(Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(byte[] v)` Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)
`ArrayNode` `add(double v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(float v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(int v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(JsonNode value)` Method for adding specified node at the end of this array.
`ArrayNode` `add(long v)` Method for adding specified number at the end of this array.
`ArrayNode` `add(Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `add(String v)` Method for adding specified String value at the end of this array.
`ArrayNode` `addAll(ArrayNode other)` Method for adding all child nodes of given Array, appending to child nodes this array contains
`ArrayNode` `addAll(Collection<JsonNode> nodes)` Method for adding given nodes as child nodes of this array node.
`ArrayNode` `addArray()` Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.
`protected void` `addContentsTo(List<JsonNode> dst)`
`ArrayNode` `addNull()` Method that will add a null value at the end of this array node.
`ObjectNode` `addObject()` Method that will construct an ObjectNode and add it at the end of this array node.
`ArrayNode` `addPOJO(Object value)` Method that will construct a POJONode and add it at the end of this array node.
`com.fasterxml.jackson.core.JsonToken` `asToken()` Method that can be used for efficient type detection when using stream abstraction for traversing nodes.
`ArrayNode` `deepCopy()` Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children.
`Iterator<JsonNode>` `elements()` Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node.
`boolean` `equals(Object o)` Equality for node objects is defined as full (deep) value equality.
`ObjectNode` `findParent(String fieldName)` Method for finding a JSON Object that contains specified field, within this node or its descendants.
`List<JsonNode>` `findParents(String fieldName, List<JsonNode> foundSoFar)`
`JsonNode` `findValue(String fieldName)` Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has.
`List<JsonNode>` `findValues(String fieldName, List<JsonNode> foundSoFar)`
`List<String>` `findValuesAsText(String fieldName, List<String> foundSoFar)`
`JsonNode` `get(int index)` Method for accessing value of the specified element of an array node.
`JsonNode` `get(String fieldName)` Method for accessing value of the specified field of an object node.
`int` `hashCode()`
`ArrayNode` `insert(int index, BigDecimal v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, boolean v)` Method that will insert specified String at specified position in this array.
`ArrayNode` `insert(int index, Boolean value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, byte[] v)` Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)
`ArrayNode` `insert(int index, double v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Double value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, float v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Float value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, int v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Integer value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, JsonNode value)` Method for inserting specified child node as an element of this Array.
`ArrayNode` `insert(int index, long v)` Method that will insert specified numeric value at specified position in this array.
`ArrayNode` `insert(int index, Long value)` Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.
`ArrayNode` `insert(int index, String v)` Method that will insert specified String at specified position in this array.
`ArrayNode` `insertArray(int index)` Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)
`ArrayNode` `insertNull(int index)` Method that will insert a null value at specified position in this array.
`ObjectNode` `insertObject(int index)` Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)
`ArrayNode` `insertPOJO(int index, Object value)` Method that will construct a POJONode and insert it at specified position in this array.
`boolean` `isArray()`
`JsonNode` `path(int index)` This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`JsonNode` `path(String fieldName)` This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned.
`JsonNode` `remove(int index)` Method for removing an entry from this ArrayNode.
`ArrayNode` `removeAll()` Method for removing all children container has (if any)
`void` `serialize(com.fasterxml.jackson.core.JsonGenerator jg, SerializerProvider provider)` Method called to serialize node instances using given generator.
`void` `serializeWithType(com.fasterxml.jackson.core.JsonGenerator jg, SerializerProvider provider, TypeSerializer typeSer)` Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.
`JsonNode` `set(int index, JsonNode value)` Method that will set specified field, replacing old value, if any.
`int` `size()` Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.
`String` `toString()` Note: marked as abstract to ensure all implementation classes define it properly.

Methods inherited from class com.fasterxml.jackson.databind.node.ContainerNode
`arrayNode, asText, binaryNode, binaryNode, booleanNode, isContainerNode, nullNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, numberNode, objectNode, POJONode, textNode`

Methods inherited from class com.fasterxml.jackson.databind.node.BaseJsonNode
`findPath, numberType, traverse`

Methods inherited from class com.fasterxml.jackson.databind.JsonNode

`asBoolean, asBoolean, asDouble, asDouble, asInt, asInt, asLong, asLong, bigIntegerValue, binaryValue, booleanValue, canConvertToInt, canConvertToLong, decimalValue, doubleValue, fieldNames, fields, findParents, findValues, findValuesAsText, has, has, intValue, isBigDecimal, isBigInteger, isBinary, isBoolean, isDouble, isFloatingPointNumber, isInt, isIntegralNumber, isLong, isMissingNode, isNull, isNumber, isObject, isPojo, isTextual, isValueNode, iterator, longValue, numberValue, textValue, with, withArray`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### _children

    protected ArrayList<JsonNode> _children

Constructor Detail

### ArrayNode

    public ArrayNode(JsonNodeFactory nc)

### ArrayNode

    protected ArrayNode(JsonNodeFactory nc,
                        ArrayList<JsonNode> children)

Method Detail

### deepCopy

    public ArrayNode deepCopy()

  Description copied from class: `JsonNode`
  Method that can be called to get a node that is guaranteed not to allow changing of this node through mutators on this node or any of its children. This means it can either make a copy of this node (and all mutable children and grand children nodes), or node itself if it is immutable.

  Note: return type is guaranteed to have same type as the node method is called on; which is why method is declared with local generic type.

  Specified by:
    `deepCopy` in class `JsonNode`
  Returns:
    Node that is either a copy of this node (and all non-leaf children); or, for immutable leaf nodes, node itself.

### asToken

    public com.fasterxml.jackson.core.JsonToken asToken()

  Description copied from class: `BaseJsonNode`
  Method that can be used for efficient type detection when using stream abstraction for traversing nodes. Will return the first `JsonToken` that equivalent stream event would produce (for most nodes there is just one token but for structured/container types multiple)

  Specified by:
    `asToken` in interface `com.fasterxml.jackson.core.TreeNode`
  Specified by:
    `asToken` in class `ContainerNode<ArrayNode>`

### isArray

    public boolean isArray()

  Overrides:
    `isArray` in class `JsonNode`
  Returns:
    True if this node represents JSON Array

### size

    public int size()

  Description copied from class: `JsonNode`
  Method that returns number of child nodes this node contains: for Array nodes, number of child elements, for Object nodes, number of fields, and for all other nodes 0.

  Specified by:
    `size` in class `ContainerNode<ArrayNode>`
  Returns:
    For non-container nodes returns 0; for arrays number of contained elements, and for objects number of fields.

### elements

    public Iterator<JsonNode> elements()

  Description copied from class: `JsonNode`
  Method for accessing all value nodes of this Node, iff this node is a JSON Array or Object node. In case of Object node, field names (keys) are not included, only values. For other types of nodes, returns empty iterator.

  Overrides:
    `elements` in class `JsonNode`

### get

    public JsonNode get(int index)

  Description copied from class: `JsonNode`
  Method for accessing value of the specified element of an array node. For other nodes, null is always returned.

  For array nodes, index specifies exact location within array and allows for efficient iteration over child elements (underlying storage is guaranteed to be efficiently indexable, i.e. has random-access to elements). If index is less than 0, or equal-or-greater than `node.size()`, null is returned; no exception is thrown for any index.

  Specified by:
    `get` in class `ContainerNode<ArrayNode>`
  Returns:
    Node that represent value of the specified element, if this node is an array and has specified element. Null otherwise.

### get

    public JsonNode get(String fieldName)

  Description copied from class: `JsonNode`
  Method for accessing value of the specified field of an object node. If this node is not an object (or it does not have a value for specified field name), or if there is no field with such name, null is returned.

  Specified by:
    `get` in class `ContainerNode<ArrayNode>`
  Returns:
    Node that represent value of the specified field, if this node is an object and has value for the specified field. Null otherwise.

### path

    public JsonNode path(String fieldName)

  Description copied from class: `JsonNode`
  This method is similar to `JsonNode.get(String)`, except that instead of returning null if no such value exists (due to this node not being an object, or object not having value for the specified field), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

  Specified by:
    `path` in class `JsonNode`

### path

    public JsonNode path(int index)

  Description copied from class: `JsonNode`
  This method is similar to `JsonNode.get(int)`, except that instead of returning null if no such element exists (due to index being out of range, or this node not being an array), a "missing node" (node that returns true for `JsonNode.isMissingNode()`) will be returned. This allows for convenient and safe chained access via path calls.

  Specified by:
    `path` in class `JsonNode`

### serialize

    public final void serialize(com.fasterxml.jackson.core.JsonGenerator jg,
                                SerializerProvider provider)
                         throws IOException,
                                com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `BaseJsonNode`
  Method called to serialize node instances using given generator.

  Specified by:
    `serialize` in interface `JsonSerializable`
  Specified by:
    `serialize` in class `BaseJsonNode`
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### serializeWithType

    public void serializeWithType(com.fasterxml.jackson.core.JsonGenerator jg,
                                  SerializerProvider provider,
                                  TypeSerializer typeSer)
                           throws IOException,
                                  com.fasterxml.jackson.core.JsonProcessingException

  Description copied from class: `BaseJsonNode`
  Type information is needed, even if JsonNode instances are "plain" JSON, since they may be mixed with other types.

  Specified by:
    `serializeWithType` in interface `JsonSerializable`
  Specified by:
    `serializeWithType` in class `BaseJsonNode`
  Throws:
    `IOException`
    `com.fasterxml.jackson.core.JsonProcessingException`

### findValue

    public JsonNode findValue(String fieldName)

  Description copied from class: `JsonNode`
  Method for finding a JSON Object field with specified name in this node or its child nodes, and returning value it has. If no matching field is found in this node or its descendants, returns null.

  Specified by:
    `findValue` in class `ContainerNode<ArrayNode>`
  Parameters:
    `fieldName` - Name of field to look for
  Returns:
    Value of first matching node found, if any; null if none

### findValues

    public List<JsonNode> findValues(String fieldName,
                                     List<JsonNode> foundSoFar)

  Specified by:
    `findValues` in class `ContainerNode<ArrayNode>`

### findValuesAsText

    public List<String> findValuesAsText(String fieldName,
                                         List<String> foundSoFar)

  Specified by:
    `findValuesAsText` in class `ContainerNode<ArrayNode>`

### findParent

    public ObjectNode findParent(String fieldName)

  Description copied from class: `JsonNode`
  Method for finding a JSON Object that contains specified field, within this node or its descendants. If no matching field is found in this node or its descendants, returns null.

  Specified by:
    `findParent` in class `ContainerNode<ArrayNode>`
  Parameters:
    `fieldName` - Name of field to look for
  Returns:
    Value of first matching node found, if any; null if none

### findParents

    public List<JsonNode> findParents(String fieldName,
                                      List<JsonNode> foundSoFar)

  Specified by:
    `findParents` in class `ContainerNode<ArrayNode>`

### set

    public JsonNode set(int index,
                        JsonNode value)

  Method that will set specified field, replacing old value, if any.

  Parameters:
    `value` - to set field to; if null, will be converted to a `NullNode` first (to remove field entry, call `remove(int)` instead)
  Returns:
    Old value of the field, if any; null if there was no old value.

### add

    public ArrayNode add(JsonNode value)

  Method for adding specified node at the end of this array.

  Returns:
    This node, to allow chaining

### addAll

    public ArrayNode addAll(ArrayNode other)

  Method for adding all child nodes of given Array, appending to child nodes this array contains

  Parameters:
    `other` - Array to add contents from
  Returns:
    This node (to allow chaining)

### addAll

    public ArrayNode addAll(Collection<JsonNode> nodes)

  Method for adding given nodes as child nodes of this array node.

  Parameters:
    `nodes` - Nodes to add
  Returns:
    This node (to allow chaining)

### insert

    public ArrayNode insert(int index,
                            JsonNode value)

  Method for inserting specified child node as an element of this Array. If index is 0 or less, it will be inserted as the first element; if >= size(), appended at the end, and otherwise inserted before existing element in specified index. No exceptions are thrown for any index.

  Returns:
    This node (to allow chaining)

### remove

    public JsonNode remove(int index)

  Method for removing an entry from this ArrayNode. Will return value of the entry at specified index, if entry existed; null if not.

### removeAll

    public ArrayNode removeAll()

  Description copied from class: `ContainerNode`
  Method for removing all children container has (if any)

  Specified by:
    `removeAll` in class `ContainerNode<ArrayNode>`
  Returns:
    Container node itself (to allow method call chaining)

### addArray

    public ArrayNode addArray()

  Method that will construct an ArrayNode and add it as a field of this ObjectNode, replacing old value, if any.

  Returns:
    Newly constructed ArrayNode

### addObject

    public ObjectNode addObject()

  Method that will construct an ObjectNode and add it at the end of this array node.

  Returns:
    Newly constructed ObjectNode

### addPOJO

    public ArrayNode addPOJO(Object value)

  Method that will construct a POJONode and add it at the end of this array node.

  Returns:
    This array node, to allow chaining

### addNull

    public ArrayNode addNull()

  Method that will add a null value at the end of this array node.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(int v)

  Method for adding specified number at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(Integer value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(long v)

  Method for adding specified number at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(Long value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(float v)

  Method for adding specified number at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(Float value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(double v)

  Method for adding specified number at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(Double value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(BigDecimal v)

  Method for adding specified number at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(String v)

  Method for adding specified String value at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(boolean v)

  Method for adding specified boolean value at the end of this array.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(Boolean value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### add

    public ArrayNode add(byte[] v)

  Method for adding specified binary value at the end of this array (note: when serializing as JSON, will be output Base64 encoded)

  Returns:
    This array node, to allow chaining

### insertArray

    public ArrayNode insertArray(int index)

  Method for creating an array node, inserting it at the specified point in the array, and returning the newly created array (note: NOT 'this' array)

### insertObject

    public ObjectNode insertObject(int index)

  Method for creating an `ObjectNode`, appending it at the end of this array, and returning the newly created node (note: NOT 'this' array)

  Returns:
    Newly constructed ObjectNode

### insertPOJO

    public ArrayNode insertPOJO(int index,
                                Object value)

  Method that will construct a POJONode and insert it at specified position in this array.

  Returns:
    This array node, to allow chaining

### insertNull

    public ArrayNode insertNull(int index)

  Method that will insert a null value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            int v)

  Method that will insert specified numeric value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            Integer value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            long v)

  Method that will insert specified numeric value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            Long value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            float v)

  Method that will insert specified numeric value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            Float value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            double v)

  Method that will insert specified numeric value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            Double value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            BigDecimal v)

  Method that will insert specified numeric value at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            String v)

  Method that will insert specified String at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            boolean v)

  Method that will insert specified String at specified position in this array.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            Boolean value)

  Alternative method that we need to avoid bumping into NPE issues with auto-unboxing.

  Returns:
    This array node, to allow chaining

### insert

    public ArrayNode insert(int index,
                            byte[] v)

  Method that will insert specified binary value at specified position in this array (note: when written as JSON, will be Base64 encoded)

  Returns:
    This array node, to allow chaining

### addContentsTo

    protected void addContentsTo(List<JsonNode> dst)

### equals

    public boolean equals(Object o)

  Description copied from class: `JsonNode`
  Equality for node objects is defined as full (deep) value equality. This means that it is possible to compare complete JSON trees for equality by comparing equality of root nodes.

  Note: marked as abstract to ensure all implementation classes define it properly and not rely on definition from `Object`.

  Specified by:
    `equals` in class `JsonNode`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### toString

    public String toString()

  Description copied from class: `JsonNode`

  Note: marked as abstract to ensure all implementation classes define it properly.

  Specified by:
    `toString` in class `JsonNode`

### _set

    public JsonNode _set(int index,
                         JsonNode value)

Copyright © 2012 fasterxml.com. All Rights Reserved.